import sys
import pandas as pd
import config

sys.path.append('..')
sys.path.append('../..')
from db.mysql_db import DB
# from utillities.sync_util import SyncUtil


class BaseCheck(object):
    def __init__(self, table):
        source_db = '''mysql+mysqlconnector://{0}:{1}@{2}:{3}/{4}'''.format(config.rl_db_user,
                                                                            config.rl_db_pwd,
                                                                            config.rl_db_host,
                                                                            config.rl_db_port,
                                                                            config.rl_db_database)
        self.db = DB(source_db)
        self.table = table
        # self.sync_util = SyncUtil()

    def _rule_and(self, df, columns):
        rule_df = pd.DataFrame({'result': [True] * len(df)})
        for column in columns:
            rule_df['result'] = rule_df['result'] & df[column]
        return rule_df['result']

    def _rule_gt(self, df, columns, values):
        rule_df = df.loc[:, columns] > values
        result = self._rule_and(rule_df, columns)
        return result

    def _rule_gte(self, df, columns, values):
        rule_df = df.loc[:, columns] >= values
        result = self._rule_and(rule_df, columns)
        return result

    def _rule_lt(self, df, columns, values):
        rule_df = df.loc[:, columns] < values
        result = self._rule_and(rule_df, columns)
        return result

    def _rule_lte(self, df, columns, values):
        rule_df = df.loc[:, columns] <= values
        result = self._rule_and(rule_df, columns)
        return result

    def _rule_notin(self, df, columns, values):
        rule_df = ~df.loc[:, columns].isin(values)
        result = self._rule_and(rule_df, columns)
        return result

    def _rule_in(self, df, columns, values):
        rule_df = df.loc[:, columns].isin(values)
        result = self._rule_and(rule_df, columns)
        return result

    def check_rule(self, df):
        i = 0
        for rule in self._rules:
            i += 1
            if rule['relation'] == 'GT':
                df['rule' + str(i)] = self._rule_gt(df, rule['columns'], rule['values'])
            elif rule['relation'] == 'GTE':
                df['rule' + str(i)] = self._rule_gte(df, rule['columns'], rule['values'])
            elif rule['relation'] == 'LT':
                df['rule' + str(i)] = self._rule_lt(df, rule['columns'], rule['values'])
            elif rule['relation'] == 'LTE':
                df['rule' + str(i)] = self._rule_lte(df, rule['columns'], rule['values'])
            elif rule['relation'] == 'IN':
                df['rule' + str(i)] = self._rule_in(df, rule['columns'], rule['values'])
            elif rule['relation'] == 'NOTIN':
                df['rule' + str(i)] = self._rule_notin(df, rule['columns'], rule['values'])
        df['rule'] = self._rule_and(df, self._rule_tag)
        return df
