#!/usr/bin/env python
# coding=utf-8
import argparse
import time

from base_check import BaseCheck


class DefaultCheck(BaseCheck):
    def __init__(self, table):
        super(DefaultCheck, self).__init__(table)

    def _get_not_check_count(self):
        sql = f'select count(1) as cou from `{self.table}` where is_verify != 1;'
        result = self.db.query_sql(sql)
        return result['cou'][0]

    def _check_data(self, check_size):
        sql = f'update `{self.table}` set is_verify=1 where is_verify!=1 order by update_time limit {check_size};'
        self.db._execute_sql(sql)

    def do_check(self):
        need_check_count = self._get_not_check_count()
        check_size = 200000
        if need_check_count > 0:
            print('need check count:', need_check_count)
            for i in range(int(need_check_count / check_size) + 1):
                start = time.time()
                self._check_data(check_size)
                print(f'check success:{check_size},time:{time.time() - start}')


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--table', type=str, default='rl_fof_fund_multi_asset_config')
    parser.add_argument('--check', type=bool, default=False)
    args = parser.parse_args()
    processor = DefaultCheck(args.table)
    if args.check:
        processor.do_check()
