#!/usr/bin/env python
# coding=utf-8
import argparse
import sys
import time

import pandas as pd

from base_publish import BasePublish

sys.path.append('..')
sys.path.append('../..')
import config


class DefaultPublish(BasePublish):
    def __init__(self, source_table, dest_table):
        super(DefaultPublish, self).__init__(source_table, dest_table)

    def get_datas(self, update_time, max_tm, id=0):
        start_time = time.time()
        print(f'正在查询 {self.source_table}表,update_time>={update_time},id>{id}')
        sql = """select *
                from `{0}` a
                where 1=1 and a.update_time>'{1}' and a.update_time<='{2}' and id>{3} and is_verify=1
                order by a.id
                limit 20000; """.format(self.source_table, update_time, max_tm, id)
        trades_sets = self.db.query_sql(sql)
        print('query data over.', time.time() - start_time)
        return trades_sets

    def update_table_data(self, tm, max_tm):
        id = 0
        while True:
            result_list = self.get_datas(tm, max_tm, id)
            if not result_list.empty:
                ids = list(result_list['id'])
                self.pub_db.delete_data_by_id(ids, self.dest_table)
                start_time = time.time()
                result_list.drop(columns=['update_time'], inplace=True)
                self.pub_db.save(result_list, self.dest_table)
                id = ids[-1]
                print('save over.', time.time() - start_time)
            else:
                self._update_publish_log(max_tm)
                print('data publish over.')
                break

    def do_update(self):
        max_tm = self._get_source_max_update_time()
        log_tm = self._get_max_tm_log()
        if max_tm > log_tm:
            self.update_table_data(log_tm, max_tm)


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--source_table', type=str, default='rl_fof_fund_multi_asset_config')
    parser.add_argument('--dest_table', type=str, default=None)
    parser.add_argument('--rebuild', type=bool, default=False)
    parser.add_argument('--update', type=bool, default=False)
    args = parser.parse_args()
    if args.dest_table is None:
        args.dest_table = args.source_table
    processor = DefaultPublish(args.source_table, args.dest_table)
    if args.rebuild:
        processor.create_dest_tables()
        processor.do_update()
    elif args.update:
        processor.check_table_columns()
        processor.do_update()
